<?php

// CuteSoft PHP Library Beta!


// Convert Error to Exception
function exception_error_handler($errno, $errstr, $errfile, $errline )
{
	if($errno==8)return false;
	throw new ErrorException($errstr, 0, $errno, $errfile, $errline);
}
set_error_handler("exception_error_handler");

class CuteSoftLibrary
{
	function NewGuid()
	{
		return preg_replace_callback("/X/",create_function("",'return substr("0123456789ABCDEF",rand(0,15),1);'),"XXXXXXXX-XXXX-XXXX-XXXX-XXXXXXXXXXXX");
	}
	function MakeAbsolute($path)
	{
		if(substr($path,0,1)=="/")
			return $path;
		$url=$_SERVER["SCRIPT_NAME"];
		$len=strlen($url);
		// for the condition "/demo/"
		if(substr($url,$len-1,1)=="/")
			return substr($url,0,$len-1)."/$path";
		// for the condtion "/demo/index.php"
		$dir=dirname($url);
		if($dir=="/")
			return "/$path";
		return $dir."/$path";
	}
	
	function FileExists($file)
	{
		return file_exists($file);
	}
	function GetBaseName($path)
	{
		return basename(str_replace("\\","/",$path));
	}
	function GetFileNameWithoutExtension($path)
	{
		$path=$this->GetBaseName($path);
		$ext=$this->GetExtension($path);
		return substr($path,0,strlen($path)-strlen($ext));
	}
	function GetExtension($filename)
	{
		$ext=pathinfo($filename,PATHINFO_EXTENSION);
		if(!$ext)return "";
		return ".$ext";
	}
	function GetFiles($folder,$pattern)
	{
		if(!$pattern)$pattern="*.*";
		$re=glob("$folder/$pattern");
		if(!$re)return array();
		return $re;
	}
	function GetFolders($folder)
	{
		$arr=array();
		foreach(scandir($folder) as $sub)
		{
			if(is_dir($sub))
			{
				array_push($arr,$sub);
			}
		}
		return $arr;
	}
	function CreateDirectory($dir)
	{
		if(is_dir($dir))
			return;
		mkdir($dir,0777);
	}
	function DeleteFile($path)
	{
		if(file_exists($path))
		{
			unlink($path);
		}
	}
	function DeleteDirectory($dir)
	{
		if(!is_dir($dir))
			return;

		foreach(scandir($dir) as $item)
		{
			if($item=="."||$item=="..")
				continue;
			$item="$dir/$item";
			if(is_dir($item))
				$this->DeleteDirectory($item);
			else
				$this->DeleteFile($item);
		}
		rmdir($dir);
	}


	function ToJSON($item)
	{
		$type=gettype($item);
		switch($type)
		{
			case "boolean":
				return $item?"true":"false";
			case "integer":
			case "double":
				return "$item";
			case "string":
				return "'$item'";
			case "array":
				if(count($item)==0)
					return "[]";
				if(array_key_exists(0,$item))	
				{
					$code="[";
					$c=count($item);
					for($i=0;$i<$c;$i++)
					{
						if($i>0)
							$code=$code.",";
						$code=$code.$this->ToJSON($item[$i]);
					}
					$code=$code."]";
					return $code;
				}
				else
				{
					$code="{";
					$i=0;
					foreach($item as $k=>$v)
					{
						if($i>0)
							$code=$code.",";
						$code=$code."'$k':".$this->ToJSON($v);
						$i++;
					}
					$code=$code."}";
					return $code;
				}
			case "NULL":
				return "null";
			case "object":
				if($item instanceof CuteSoftDateTime)
				{
					return $item->ToJSON();
				}
			case "resource":
			case "unknown type":
			default:
				return "'$type'";
		}
	}
	
	function ProcessAjaxPostback()
	{
		if(@$_GET["GalleryAjaxInvoke"]!="1")
			return;
		$context=new CuteSoftAjaxContext();
		$context->Process($this);
		exit();
	}
	
	//inherits this function..
	function InvokeAjaxMethod($context)
	{
	
	}
	
}

class CuteSoftDateTime
{
	var $time;
	function CuteSoftDateTime($inittime)
	{
		$this->time=$inittime;
	}
	function ToJSON()
	{
		return "new Date(".($this->time*1000).")";
	}
	function GetTime()
	{
		return $this->time;
	}
}

class CuteSoftAjaxContext
{
	public $Instance;
	public $Method;
	public $Arguments;
	public $Result;
	public $Error;

	function Process($instance)
	{
		$this->Instance=$instance;
		try
		{
			$this->InternalProcess();
			$doc=new DOMDocument();
			$doc->loadXML("<ajax/>");
			$root=$doc->childNodes->item(0);
			$res=$doc->createElement("result");
			$this->ConvertToElement($this->Result,$res);
			$response=$doc->createElement("response");
			$root->appendChild($response);
			$response->appendChild($res);
			header("Content-Type: text/xml");
			echo $doc->saveXML();
		}
		catch(Exception $x)
		{
			$this->Error=$x;
			
			$doc=new DOMDocument();
			$doc->loadXML("<ajax/>");
			$root=$doc->childNodes->item(0);
			$err=$doc->createElement("exception");
			$err->setAttribute("t","Exception");
			$err->setAttribute("message", $x->getMessage()." @ ".$x->getFile().":".$x->getLine());
			$err->setAttribute("stacktrace", $x->getTraceAsString());
			$err->textContent=$x->getMessage()." @ ".$x->getFile().":".$x->getLine()."\r\n".$x->getTraceAsString();
			$root->appendChild($err);
			header("Content-Type: text/xml");
			echo $doc->saveXML();
		}
	}
	function InternalProcess()
	{
		$this->Method=$_POST["GalleryAjaxInvoke_Method"];
		
		$args=$_POST["GalleryAjaxInvoke_Arguments"];
		$args=str_replace("-5",'"',$args);
		$args=str_replace("-4","'",$args);
		$args=str_replace("-3","&",$args);
		$args=str_replace("-2",">",$args);
		$args=str_replace("-1","<",$args);
		$args=str_replace("-0","-",$args);
		$args="<args>$args</args>";
		
		$this->Arguments=array();
		$doc=new DOMDocument();
		$doc->loadXML($args);
		$ns=$doc->childNodes->item(0)->childNodes;
		for($i=0;$i<$ns->length;$i++)
		{
			$node=$ns->item($i);
			if($node->nodeType!=1)continue;
			array_push($this->Arguments,$this->ConvertFromElement($node));
		}
		
		$this->Result=$this->Instance->InvokeAjaxMethod($this);
	}
	
	function ConvertFromElement($element)
	{
		switch($element->getAttribute("t"))
		{
			case "undefined":
				return null;
			case "null":
				return null;
			case "boolean":
				switch(strtolower($element->getAttribute("v")))
				{
					case "true":	return true;
					case "1":		return true;
					case "-1":		return true;
					case "false":	return false;
					case "0":		return false;
					default:
						throw(new Exception("invalid boolean expression:".$element->getAttribute("v")));
				}
			case "number":
				return $element->getAttribute("v")+0;
			case "string":
				return $element->getAttribute("v");
			case "datetime":
				return new CuteSoftDateTime($element->getAttribute("v")/1000);
			case "array":
				$arr=array();
				$ns=$element->childNodes;
				for($i=0;$i<$ns->length;$i++)
				{
					$node=$ns->item($i);
					if($node->nodeType!=1)continue;
					array_push($arr,$this->ConvertFromElement($node));
				}
				return $arr;
			case "complex":
				$arr=array();
				$ns=$element->childNodes;
				for($i=0;$i<$ns->length;$i++)
				{
					$node=$ns->item($i);
					if($node->nodeType!=1)continue;
					$arr[$node->getAttribute("p")]=$this->ConvertFromElement($node);
				}
				return $arr;
			default:
				throw(new Exception("unknown @t : ".$element->getAttribute("t")));
		}
	}
	function ConvertToElement($item,$element)
	{
		$type=gettype($item);
		switch($type)
		{
			case "boolean":
				$element->setAttribute("t","boolean");
				$element->setAttribute("v",$item?"true":"false");
				return;
			case "integer":
			case "double":
				$element->setAttribute("t","number");
				$element->setAttribute("v",$item);
				return;
			case "string":
				$element->setAttribute("t","string");
				$element->setAttribute("v",$item);
				return;
			case "array":
				if(count($item)==0)
				{
					$element->setAttribute("t","array");
					return;
				}
				if(array_key_exists(0,$item))	
				{
					$element->setAttribute("t","array");
					foreach($item as $subitem)
					{
						$sube=$element->ownerDocument->createElement("i");
						$this->ConvertToElement($subitem,$sube);
						$element->appendChild($sube);
					}
					return;
				}
				else
				{
					$element->setAttribute("t","complex");
					foreach($item as $subkey=>$subitem)
					{
						$sube=$element->ownerDocument->createElement("i");
						$sube->setAttribute("p",$subkey);
						$this->ConvertToElement($subitem,$sube);
						$element->appendChild($sube);
					}
					return;
				}
			case "NULL":
				$element->setAttribute("t","null");
				return;
			case "object":
				if($item instanceof CuteSoftDateTime)
				{
					$element->setAttribute("t","datetime");
					$element->setAttribute("v",$item->GetTime()*1000);
					return;
				}
			case "resource":
			case "unknown type":
			default:
				$element->setAttribute("t","null");
				return;
		}
	}
}

?>